--- a/debian/changelog
+++ b/debian/changelog
@@ -1,3 +1,10 @@
+boost1.46 (1.46.1-6.1) unstable; urgency=low
+
+  * Non-maintainer upload.
+  * Build boost.python for python-dbg with a -dbg suffix.
+
+ -- Cristian Greco <cristian@regolo.cc>  Sun, 19 Jun 2011 18:20:43 +0200
+
 boost1.46 (1.46.1-6) unstable; urgency=low
 
   * control(libboost-mpi-python1.46.1, libboost-python1.46.1): Suggests a
--- a/debian/control
+++ b/debian/control
@@ -7,8 +7,8 @@
 Build-Depends: debhelper (>= 8), 
  zlib1g-dev, libbz2-dev, libicu-dev, mpi-default-dev,
  bison, flex, docbook-to-man, help2man, xsltproc, doxygen, 
- python, python-all-dev, 
- python3, python3-all-dev (>= 3.1)
+ python, python-all-dev, python-all-dbg,
+ python3, python3-all-dev (>= 3.1), python3-all-dbg (>= 3.1)
 Build-Conflicts: libopenmpi-dev (= 1.3.2-2)
 Vcs-Browser: http://svn.debian.org/wsvn/pkg-boost/boost/trunk/
 Vcs-Svn: svn://svn.debian.org/svn/pkg-boost/boost/trunk
--- a/debian/rules
+++ b/debian/rules
@@ -14,6 +14,8 @@
 SHLIBS_VERSION = (>= 1.46.1-1)
 
 pyversions = $(shell pyversions -rv) $(shell py3versions -rv)
+dbgpyversions = $(pyversions:%=%-dbg)
+allpyversions = $(pyversions) $(dbgpyversions)
 
 # Boost libraries for which we want separate packages
 boost_libs := date-time filesystem graph-parallel graph iostreams math \
@@ -29,7 +31,7 @@
 boost_lib_test := prg_exec_monitor test_exec_monitor unit_test_framework
 
 # These are special cases for suffixes.  Generally come from --python-buildid, so begin with a dash.
-boost_suffixes_python := $(addprefix -py,$(subst .,,$(pyversions)))
+boost_suffixes_python := $(addprefix -py,$(subst .,,$(allpyversions)))
 boost_suffixes_mpi-python := $(boost_suffixes_python)
 
 # Files that are generated by filtering a template
@@ -172,6 +174,9 @@
 	for pyver in $(filter-out $(shell pyversions -dv),$(pyversions)); do \
 		echo "using python : $$pyver : /usr ;" >> $@; \
 	done
+	for pyver in $(pyversions); do \
+		echo "using python : $$pyver : /usr : /usr/include/python$${pyver}_d : : <python-debugging>on ;" >> $@; \
+	done
 
 build: build-stamp
 build-stamp: $(bjam) user-config.jam
@@ -183,6 +188,7 @@
 		echo "Building Boost.Python for python version $$pyver"; \
 	 	$(JAM) --with-python --with-mpi --python-buildid=py$$pyid python=$$pyver; \
 	 	mv stage/lib/mpi.so stage/lib/mpi-py$$pyid.so; \
+	 	$(JAM) --with-python --with-mpi --python-buildid=py$$pyid-dbg python=$$pyver python-debugging=on; \
 	done
 
 	cd $(bbv2dir) && ./bootstrap.sh --with-toolset=gcc
@@ -243,6 +249,7 @@
 	for pyver in $(pyversions); do \
 		pyid=`echo $$pyver | tr -d .`; \
 		$(JAM) --prefix=$(CURDIR)/debian/tmp/usr install --with-python --with-mpi --python-buildid=py$$pyid python=$$pyver; \
+		$(JAM) --prefix=$(CURDIR)/debian/tmp/usr install --with-python --with-mpi --python-buildid=py$$pyid-dbg python=$$pyver python-debugging=on; \
 	done
 
 	# Install Boost.Build v2 & jam
